-- author Rival

claasLexion400 = {};

function claasLexion400.prerequisitesPresent(specializations)
    print("......LOADING CLAAS LEXION 430/460 Pack by RIVAL......");
    return SpecializationUtil.hasSpecialization(Motorized, specializations) and SpecializationUtil.hasSpecialization(Overloading, specializations);
end

function claasLexion400:load(savegame)
    self.threshingStartPS = {};
    ParticleUtil.loadParticleSystem(self.xmlFile, self.threshingStartPS, "vehicle.threshingStartParticleSystem", self.components, false, nil, self.baseDirectory);
	self.threshingStartPSoffset = {};
    self.threshingStartPSoffset[1] = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.threshingStartParticleSystem#startOffset1"),0.1)*1000;
    self.threshingStartPSoffset[2] = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.threshingStartParticleSystem#startOffset2"),0.2)*1000;
    self.threshingStartPStimer = 0;
	
	self.grainTankCapacities = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.grainTankCapacities.capacity(%d)", i);
		if not hasXMLProperty(self.xmlFile, key) then
            break;
        end
		local fillVolumeIndex = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#fillVolumeIndex"));
		local capacity = getXMLFloat(self.xmlFile, key .. "#capacity");
		local configurationId = getXMLFloat(self.xmlFile, key .. "#configurationId");
		if configurationId ~= nil and capacity ~= nil and fillVolumeIndex ~= nil then
			if self.grainTankCapacities[configurationId] ~= nil then
				print("More than one grain tank capacity per configuration is not allowed!");
			else
				self.grainTankCapacities[configurationId] = {};
				self.grainTankCapacities[configurationId].capacity = capacity;
				self.grainTankCapacities[configurationId].fillVolumeIndex = fillVolumeIndex;
			end
		else
			print("GrainTankCapacities Error: Configuration in xml not correct!");
			break;
		end
		i = i + 1;
	end
end

function claasLexion400:postLoad()
	if self.isClient then
		if self:getUnitCapacity(1) ~= self.grainTankCapacities[self.configurations["motor"]].capacity then
			self:setUnitCapacity(1, self.grainTankCapacities[self.configurations["motor"]].capacity);
			local fillVolume = self.fillVolumes[1];
			setVisibility(fillVolume.volume, false);
			fillVolume.baseNode = self.grainTankCapacities[self.configurations["motor"]].fillVolumeIndex;
			fillVolume.volume = createFillPlaneShape(fillVolume.baseNode, "fillPlane", self.grainTankCapacities[self.configurations["motor"]].capacity, fillVolume.maxDelta, fillVolume.maxSurfaceAngle, math.rad(35), fillVolume.maxSubDivEdgeLength, fillVolume.allSidePlanes);
			link(fillVolume.baseNode, fillVolume.volume);
		end
	end
end

function claasLexion400:delete()
    ParticleUtil.deleteParticleSystem(self.threshingStartPS);
end
function claasLexion400:mouseEvent(posX, posY, isDown, isUp, button)
end
function claasLexion400:keyEvent(unicode, sym, modifier, isDown)
end
function claasLexion400:update(dt)
end
function claasLexion400:updateTick(dt)
    if self:getIsActive() then
        if self.isClient then
            if SoundUtil.isSamplePlaying(self.sampleThreshingStart) then
                if self.threshingStartPStimer >= self.threshingStartPSoffset[self.configurations["motor"]] then
                    ParticleUtil.setEmittingState(self.threshingStartPS, true);
                else
                    self.threshingStartPStimer = self.threshingStartPStimer+dt;
                end
            else
				if self.threshingStartPStimer > 0 then
					ParticleUtil.setEmittingState(self.threshingStartPS, false);
					self.threshingStartPStimer = 0;
				end
            end
			if self:getUnitCapacity(1) ~= self.grainTankCapacities[self.configurations["motor"]].capacity then
				self:setUnitCapacity(1, self.grainTankCapacities[self.configurations["motor"]].capacity);
				local fillVolume = self.fillVolumes[1];
			setVisibility(fillVolume.volume, false);
				fillVolume.baseNode = self.grainTankCapacities[self.configurations["motor"]].fillVolumeIndex;
				fillVolume.volume = createFillPlaneShape(fillVolume.baseNode, "fillPlane", self.grainTankCapacities[self.configurations["motor"]].capacity, fillVolume.maxDelta, fillVolume.maxSurfaceAngle, math.rad(35), fillVolume.maxSubDivEdgeLength, fillVolume.allSidePlanes);
				link(fillVolume.baseNode, fillVolume.volume);
			end
        end
    end
end
function claasLexion400:draw()
end